/*
 *  Copyright (c) 2002 kinpobj
 *
 */


#ifndef	A400_DEV

#define	A400_MTU			1500
#define	A400_MAX_MTU		1536

#define	A400_RUNNING		0x00000002
#define	A400_TX_BUSY		0x00000004
#define	A400_RX_BUSY		0x00000008
#define	CTRL_URB_RUNNING	0x00000010
#define	CTRL_URB_SLEEP		0x00000020
#define	A400_UNPLUG			0x00000040

#define A400_SEND_NUMBER	48

#define	A400_TX_TIMEOUT		(HZ*10)

#define	A400_CTRL_READ		0xa1
#define	ALIGN(x)			x __attribute__((aligned(L1_CACHE_BYTES)))


struct send_context {
	__u8			index;
	__u8			used ;
	unsigned char	ALIGN(tx_buff[A400_MAX_MTU]);
};

typedef struct a400 {
	struct usb_device			*usb;
	struct net_device			*net;
	struct net_device_stats		stats;
	struct timer_list			timer;
	unsigned					flags;
	unsigned					features;
	int						dev_index;
	struct urb					ctrl_urb, rx_urb, tx_urb;
	devrequest					dr;
	wait_queue_head_t			usb_wait;
	unsigned char				ALIGN(rx_buff[A400_MAX_MTU]);
	struct send_context			send_queue[A400_SEND_NUMBER];
	int						current_id;
	spinlock_t 					device_lock;
} a400_t;


struct usb_eth_dev {
	char	*name;
	__u16	vendor;
	__u16	device;
	__u32	private; /* LSB is gpio reset value */
};


#else	/* A400_DEV */


A400_DEV( "A400 USB Ethernet", 0x0f35, 0x1461, 0 )
A400_DEV( "A400 USB Ethernet", 0x07a6, 0x0988, 0 )
A400_DEV( "A400 USB Ethernet", 0x0f7c, 0x7090, 0 )

#endif	/* A400_DEV */
